# -*- coding: utf-8 -*-

"""
Module implementing MainWindow.
"""

from PyQt4.QtCore import *
from PyQt4.QtGui import *

from Ui_mainwindow import Ui_MainWindow
from res_rc import *

class MainWindow(QMainWindow, Ui_MainWindow):
    """
    Class documentation goes here.
    """
    def __init__(self, parent = None):
        """
        Constructor
        """
        QMainWindow.__init__(self, parent)
        self.setupUi(self)
    
    @pyqtSignature("")
    def on_pushButton_hello_clicked(self):
        """
        Slot documentation goes here.
        """
        QMessageBox.information(self,  "Hi",  "My godness")
        
#        raise NotImplementedError
    
    @pyqtSignature("int")
    def on_horizontalSlider_valueChanged(self, value):
        """
        Slot documentation goes here.
        """
        self.label_value.setText(QVariant(value).toString())
        # TODO: not implemented yet
#        raise NotImplementedError
    
    @pyqtSignature("bool")
    def on_pushButton_lang_clicked(self, checked):
        """
        Slot documentation goes here.
        """
        # TODO: not implemented yet
        if checked:
            self.pushButton_lang.setText('is Arabic')
            self.changeLangauge('ar')
        else:
            self.pushButton_lang.setText('is Default')
            self.changeLangauge('en')
    
    def changeLangauge(self,  lang):
        translator = QTranslator(self)
        currentLangFile = QString(":/i18n/%1").arg(lang)
        if translator.load(currentLangFile):
            widget = QWidget(self)
            if lang == 'ar':
                qApp.setLayoutDirection(Qt.RightToLeft)
                QLocale.setDefault(QLocale(QLocale.Arabic, QLocale.SyrianArabRepublic))
                for widget in qApp.allWidgets():
                    widget.setLayoutDirection(Qt.RightToLeft)
            else:
                qApp.setLayoutDirection(Qt.LeftToRight)
                for widget in qApp.allWidgets():
                    widget.setLayoutDirection(Qt.LeftToRight)
            qApp.installTranslator(translator)
            self.retranslateUi(self)
        else:
            print QString("Couldn't load language file")
